package com.bergerkiller.bukkit.nolagg;

import net.minecraft.server.Chunk;

import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.world.ChunkUnloadEvent;

import com.all.bukkit.threadcheck.ThreadCheck;
import com.bergerkiller.bukkit.nolagg.meta.ChunkMetaData;
import com.bergerkiller.bukkit.nolagg.meta.WorldMetaData;

public class NLMonitoredListener implements Listener {
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onEntityExplode(EntityExplodeEvent event) {
		if (!ThreadCheck.check("")) return;
		if (!event.isCancelled()) {
			if (TnTHandler.createExplosion(event)) {
				//I know, we monitor, but the end result is the same anyway!
				event.setCancelled(true);
			}
		}
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onChunkUnload(ChunkUnloadEvent event) {
		if (event.isCancelled()) {
			ChunkMetaData.get(event.getChunk()).markNotUnloadable();
		} else {
			WorldMetaData.get(event.getWorld()).removeChunk(event.getChunk().getX(), event.getChunk().getZ());
			NLListener.unloadedChunks++;
			Chunk chunk = ChunkHandler.getNative(event.getChunk());
			if (chunk instanceof BufferedChunk) {
			    ((BufferedChunk) chunk).markUnloadedSoon();
			}
		}
	}
	
}
